Home My Page Projects Code Snippets Project Openings SML/NJ
Summary Activity Forums Tracker Lists Tasks Docs Surveys News SCM Files

SCM Repository

[smlnj] Diff of /sml/trunk/config/install.sh
ViewVC logotype

Diff of /sml/trunk/config/install.sh

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

sml/branches/SMLNJ/config/install.sh revision 249, Sat Apr 17 18:57:03 1999 UTC sml/trunk/config/install.sh revision 1251, Fri Jul 5 15:56:34 2002 UTC
# Line 2  Line 2 
2  #  #
3  # Copyright (c) 1994 AT&T Bell Laboratories.  # Copyright (c) 1994 AT&T Bell Laboratories.
4  #  #
5  # installation script for SML/NJ and related tools; this is a temporary  # Installation script for SML/NJ and related tools; this is a temporary
6  # placeholder until the configuration tool is finished.  # placeholder until the configuration tool is finished.
7  #  #
8    # Significant changes to accommodate (and take advantage of) the new CM
9    # by M.Blume (2/2000).
10    #
11    
12    if [ x${INSTALL_QUIETLY} = xtrue ] ; then
13        export CM_VERBOSE=false
14    fi
15    
16    vsay() {
17        if [ x${INSTALL_DEBUG} = xtrue ] ; then
18            echo "$@"
19        elif [ x${INSTALL_QUIETLY} = xtrue ] ; then
20            :
21        else
22            echo "$@"
23        fi
24    }
25    
26    dsay() {
27        if [ x${INSTALL_DEBUG} = xtrue ] ; then
28            echo "$@"
29        fi
30    }
31    
32    complain() {
33        echo "$@"
34        exit 1
35    }
36    
37    # The following variable holds the name of all possible targets.
38    # The names must occur in the order in which targets are to be built.
39    ALLTARGETS=\
40    "src-smlnj \
41     ml-yacc \
42     ml-lex \
43     ml-burg \
44     ml-nlffigen \
45     smlnj-lib \
46     cml \
47     cml-lib \
48     eXene \
49     ckit \
50     ml-nlffi-lib \
51     pgraph-util \
52     mlrisc-tools \
53     nowhere \
54     doc"
55    
56    this=$0
57    
58    # By default, move libraries to lib directory:
59    MOVE_LIBRARIES=true
60    
61    # function to be used in config/targets:
62    dont_move_libraries() { MOVE_LIBRARIES=false ; }
63    
64  #set -x  # Initialize target list.
65    TARGETS=""
66    
67    # function to be used in config/targets:
68    request() { TARGETS="$TARGETS $1" ; }
69    
70  #  #
71  # get the target list  # get the target list
72  #  #
73  if [ ! -r config/targets ]; then  if [ -r config/targets.customized ] ; then
74    echo "!!! no target list"      . config/targets.customized
75    exit 1;  elif [ ! -r config/targets ]; then
76  fi      complain "$this: !!! File config/targets is missing."
77    else
78  . config/targets  . config/targets
79    fi
80    
81  #  #
82  # some OSs have make in strange places  # resolve dependencies
83  #  #
84  MAKE=make  isnotin() {
85        tested_x=$1
86        shift
87        for set_y in "$@" ; do
88            if [ ${tested_x} = ${set_y} ] ; then
89                return 1
90            fi
91        done
92        return 0
93    }
94    
95    require() {
96        require_who=$1
97        shift
98        if isnotin ${require_who} ${TARGETS} ; then
99            :
100        else
101            for required_x in "$@" ; do
102                if isnotin ${required_x} ${TARGETS} ; then
103                    echo "Including ${required_x} (needed by ${require_who})."
104                    request ${required_x}
105                    CHANGED=true
106                fi
107            done
108        fi
109    }
110    
111    onepass() {
112        while read depline ; do
113            require $depline
114        done
115    }
116    
117    if [ -r config/dependencies ] ; then
118        CHANGED=true
119        while [ $CHANGED = true ]; do
120            CHANGED=false
121            onepass <config/dependencies
122        done
123    fi
124    
125  #  #
126  # command for building SML libraries; this should be either  # Rebuild target list using the order defined by ALLTARGETS.
 # "CM.recompile()" or "CM.stabilize true".  The latter builds  
 # stable libraries, which may be somewhat faster to use.  
127  #  #
128  #CM_MAKE_LIB="CM.recompile();"  NEWTARGETS=""
129  CM_MAKE_LIB="CM.stabilize true;"  for t in ${ALLTARGETS} ; do
130        if isnotin $t ${TARGETS} ; then
131            :
132        else
133            NEWTARGETS="$NEWTARGETS $t"
134        fi
135    done
136    TARGETS=$NEWTARGETS
137    
138  #  #
139  # check for ksh  # create the preloads.standard file
140  #  #
141  # ksh causes some people problems so we will always use /bin/sh  if [ ! -r config/preloads ]; then
142        complain "$this: !!! File config/preloads is missing."
143    fi
144    cp config/preloads preloads.standard
145    
146  #  #
147  #echo "checking for ksh"  # Some OSs have make in strange places, but most of the time it is
148  #if [ -x /bin/ksh ]; then  # simply on the PATH:
149  #  SHELL=/bin/ksh  #
150  #elif [ -x /usr/local/bin/ksh ]; then  MAKE=make
151  #  SHELL=/usr/local/bin/ksh  
 #else  
152    SHELL=/bin/sh    SHELL=/bin/sh
153  #fi  vsay $this: Using shell $SHELL.
 echo "  using $SHELL"  
154    
155  #  #
156  # set the SML root directory  # set the SML root directory
157  #  #
158  REAL_PWD=`pwd`  REAL_PWD=`pwd`
159  ROOT=${PWD:-$REAL_PWD}  ROOT=${PWD:-$REAL_PWD}
160  echo "SML root is $ROOT"  vsay $this: SML root is $ROOT.
161    vsay $this: Installation directory is ${INSTALLDIR:=$ROOT}.
162    
163  #  #
164  # set the various directory pathname variables  # set the various directory and file pathname variables
165  #  #
166  BINDIR=$ROOT/bin  BINDIR=$INSTALLDIR/bin          # main dir for binary stuff
167  CONFIGDIR=$ROOT/config  CONFIGDIR=$ROOT/config
168  HEAPDIR=$BINDIR/.heap  HEAPDIR=$BINDIR/.heap           # where heap images live
169  RUNDIR=$BINDIR/.run  RUNDIR=$BINDIR/.run             # where executables (i.e., the RTS) live
170  SRCDIR=$ROOT/src  SRCDIR=$ROOT/src                # where the source tree is rooted
171  LIBDIR=$ROOT/lib  LIBDIR=$INSTALLDIR/lib          # where libraries live
172    LIBLIST=$ROOT/liblist           # list of commands to stabilize libraries
173    LATESTANDALONES=$ROOT/latestandalones # standalone programs to be built late
174    LIBMOVESCRIPT=$ROOT/libmove     # a temporary script
175    LOCALPATHCONFIG=$INSTALLDIR/pathconfig # a temporary pathconfig file
176    
177  #  #
178  # the paths to ml-yacc and ml-lex; needed to configure CM  # The path to the dir where ml-yacc, ml-burg, ml-lex, ml-build, and
179    # ml-makedepend live.  This path will be interpreted relative to $LIBDIR.
180  #  #
181  YACCPATH=$BINDIR/ml-yacc  TOOLDIR=../bin
182  LEXPATH=$BINDIR/ml-lex  
183  BURGPATH=$BINDIR/ml-burg  #
184    # A temporary file for post-editing the pathconfig file...
185    #
186    PCEDITTMP=$INSTALLDIR/pcedittmp.$$
187    
188    #
189    # files to be deleted after we are done...
190    #
191    tmpfiles=""
192    tmpfiles="$tmpfiles $ROOT/preloads.standard"
193    tmpfiles="$tmpfiles $LIBLIST"
194    tmpfiles="$tmpfiles $LATESTANDALONES"
195    tmpfiles="$tmpfiles $LOCALPATHCONFIG"
196    tmpfiles="$tmpfiles $LIBMOVESCRIPT"
197    tmpfiles="$tmpfiles $PCEDITTMP"
198    #
199    # make sure we always clean up after ourselves...
200    #
201    trap 'rm -f $tmpfiles' 0 1 2 3 15
202    
203    
204  #  #
205  # set the CM configuration variables (these are environment variables  # set the CM configuration variables (these are environment variables
206  # that will be queried by the bootstrap code)  # that will be queried by the bootstrap code)
207  #  -M.Blume (5/1998)  # Especially important is CM_PATHCONFIG.
208  #  #
209  CM_YACC_DEFAULT=$YACCPATH  CM_PATHCONFIG=$LIBDIR/pathconfig
210  CM_LEX_DEFAULT=$LEXPATH  export CM_PATHCONFIG
 CM_BURG_DEFAULT=$BURGPATH  
 CM_PATH_DEFAULT=.:$LIBDIR  
 export CM_YACC_DEFAULT CM_LEX_DEFAULT CM_BURG_DEFAULT CM_PATH_DEFAULT  
211    
212  #  #
213  # the release version that we are installing  # the release version that we are installing
214  #  #
215  VERSION=`cat $CONFIGDIR/version`  VERSION=`cat $CONFIGDIR/version`
216  echo "installing version $VERSION"  vsay $this: Installing version $VERSION.
217    
218  #  #
219  # create the various sub directories  # the URL for the (usually remote) source archive
220  #  #
221  for dir in $BINDIR $HEAPDIR $RUNDIR $LIBDIR $SRCDIR  SRCARCHIVEURL=`cat $CONFIGDIR/srcarchiveurl`
222  do  vsay $this: URL of source archive is $SRCARCHIVEURL.
223    if [ -d $dir ]; then  
224      echo "$dir already exists"  #
225    # Function to make a directory including its ancestors.
226    #
227    makedir() {
228        if [ x$1 = x ] ; then
229            :
230        elif [ -d $1 ] ; then
231            :
232    else    else
233      echo "creating $dir"          makedir `dirname $1`
234      mkdir $dir          if [ x${INSTALL_VERBOSE} = xtrue ] ; then
235      if [ $? != "0" ]; then              vsay "$this: Making directory $1"
236        echo "unable to create $dir"          fi
237        exit 1          if mkdir $1 ; then
238                :
239            else
240                complain "$this: !!! Unable to make directory $1!"
241      fi      fi
242    fi    fi
243    }
244    
245    #
246    # Function for asking user to fetch source archive.
247    #   $1 - descriptive name
248    #   $2 - base name without extension, without version, and without dir
249    #   $3 - remote directory
250    #
251    askurl() {
252        echo "$this: Please, fetch $1 archive"
253        echo ' ('$2.'*' or $VERSION-$2.'*)'
254        echo " from $3"
255        echo " and then re-run this script!"
256        exit 1
257    }
258    
259    #
260    # Function for fetching source archives automatically using wget or lynx.
261    #   $1 - command to actually get the stuff
262    #   $2 - descriptive name
263    #   $3 - base name without extension and without dir
264    #   $4 - remote directory
265    #
266    fetchurl() {
267        getter=$1 ; shift
268        vsay $this: Fetching $1 from $3. Please stand by...
269        fetched=no
270        for base in $2 $VERSION-$2 ; do
271            for ext in tgz tar.gz tar.Z tz tar tar.bz2 ; do
272                try=$base.$ext
273                vsay $this: Trying $try ...
274                if $getter $3/$try $ROOT/$try ; then
275                    fetched=yes
276                    vsay $this: Fetching $try was a success.
277                    break 2         # get out of both for-loops
278                else
279                    rm -f $ROOT/$try
280                fi
281            done
282  done  done
283        if [ $fetched = no ] ; then
284            echo $this: Fetching $try was no success.
285            echo '  ' You should try to do it manually now.
286            askurl "$1" "$2" "$3"
287        fi
288    }
289    
290    # wrapper for wget
291    usewget() {
292        wget -nv -O $2 $1
293    }
294    
295    # wrapper for lynx
296    uselynx() {
297        lynx -source $1 >$2
298    }
299    
300    # wrapper for curl
301    usecurl() {
302        curl -s $1 >$2
303    }
304    
305    testurlgetter() {
306        (exec >/dev/null 2>&1 ; exec $*)
307    }
308    
309    #
310    # Function to check whether wget or lynx is available.
311    # Set URLGETTER accordingly.  URLGETTER can be set externally
312    # to either 'wget' or 'curl' or 'lynx' -- in which case the
313    # corresponding command will be used (properly wrapped).  Any
314    # other external setting will be passed directly to fetchurl (without
315    # wrapping -- meaning it must take precisely two argumets: source and
316    # destination, in that order).
317    #
318    urlgetter() {
319        case ${URLGETTER:-unknown} in
320            fetchurl*)
321                ;;
322            unknown)
323                # automatically figure out which wrapper to use
324                if testurlgetter wget --help ; then
325                    URLGETTER="fetchurl usewget"
326                elif testurlgetter curl -s -O file:///dev/null -o /dev/null ; then
327                    URLGETTER="fetchurl usecurl"
328                elif testurlgetter lynx -help ; then
329                    URLGETTER="fetchurl uselynx"
330                else
331                    URLGETTER="askurl"
332                fi
333                ;;
334            wget|curl|lynx)
335                # special getters we know how to wrap
336                URLGETTER="fetchurl use${URLGETTER}"
337                ;;
338            *)
339                # other -- must be able to work without wrapper
340                URLGETTER="fetchurl ${URLGETTER}"
341                ;;
342        esac
343    }
344    
345    # wrapper for tar
346    un_tar() {
347        vsay "$this: Un-TAR-ing $1 archive."
348        tar -xf $2
349    }
350    
351    # wrapper for zcat followed by tar
352    un_tar_Z() {
353        vsay "$this: Un-COMPRESS-ing and un-TAR-ing $1 archive."
354        zcat $2 | tar -xf -
355    }
356    
357    # wrapper for gunzip followed by tar
358    un_tar_gz() {
359        vsay "$this: Un-GZIP-ing and un-TAR-ing $1 archive."
360        gunzip -c $2 | tar -xf -
361    }
362    
363    # wrapper for bunzip2 followed by tar
364    un_tar_bz2() {
365        vsay "$this: Un-BZIP2-ing and un-TAR-ing $1 archive."
366        bunzip2 -c $2 | tar -xf -
367    }
368    
369    # unarchive archive without and with version number attached
370    unarchive() {
371        # $1: descriptive string, $2: archive, $3: unpacker
372        if [ -r $ROOT/$2 ] ; then
373            $3 "$1" $ROOT/$2
374        elif [ -r $ROOT/$VERSION-$2 ]; then
375            $3 "$1" $ROOT/$VERSION-$2
376        else
377            return 1
378        fi
379    }
380    
381    #
382    # Function to unpack a source archive.
383    #
384    # $1: descriptive name of the sources to be unpacked
385    # $2: the directory into which to unpack the sources
386    # $3: the sub-directory of $2 that is going to be created by unpacking
387    # $4: the basename of the source archive (the script will check several
388    #     different suffixes to determine what kind of de-compression is to
389    #     be used)
390    #
391    # fetch_n_unpack is the helper function that does the real work.  If
392    # no archive is found locally, it invokes $URLGETTER and tries again.
393    # The variable $tryfetch is used to make sure this happens only once.
394    fetch_n_unpack() {
395        cd $2
396        if unarchive "$1" $4.tar.gz un_tar_gz ||
397           unarchive "$1" $4.tgz un_tar_gz ||
398           unarchive "$1" $4.tar.Z un_tar_Z ||
399           unarchive "$1" $4.tar un_tar ||
400           unarchive "$1" $4.tar.bz2 un_tar_bz2 ||
401           unarchive "$1" $4.tz un_tar_Z
402        then
403            : we are done
404        elif [ $tryfetch = yes ] ; then
405            urlgetter
406            $URLGETTER "$1" $4 $SRCARCHIVEURL
407            tryfetch=no
408            fetch_n_unpack "$1" "$2" "$3" "$4"
409        fi
410    }
411    
412    #
413    # The main "unpack" driver function that invokes the above helper.
414    #
415    unpack() {
416        tryfetch=yes
417        if [ -d $2/$3 ]; then
418            vsay "$this: The $1 tree already exists."
419        else
420            fetch_n_unpack "$1" "$2" "$3" "$4"
421        fi
422        if [ ! -d $2/$3 ]; then
423            complain "$this: !!! Unable to unpack $1 archive."
424        fi
425    }
426    
427    # A function to move all stable library files to a parallel directory
428    # hierarchy.
429    # The first argument must be a simple path (no / inside), and
430    # the second argument must be an absolute path.
431    move() {
432        if [ -d $1 ] ; then
433            if [ ! -d $2 ] ; then
434                if [ -f $2 ] ; then
435                    complain $this: $2 exists as a non-directory.
436                fi
437                mkdir $2
438            fi
439            cd $1
440            for i in * ; do
441                move $i $2/$i
442            done
443            cd ..
444        elif [ -f $1 ] ; then
445            rm -f $2
446            mv $1 $2
447        fi
448    }
449    
450    # move stable library file from $1 to $2
451    movelib()
452    {
453        SOURCE=$1
454        TARGET=$2
455        TARGETDIR=`dirname ${TARGET}`
456        if [ ! -d ${TARGETDIR} ] ; then
457            makedir ${TARGETDIR}
458        fi
459        mv ${SOURCE} ${TARGET}
460    }
461    
462    # A shell function that registers a library for being built.
463    # This function takes 3 arguments:
464    #   $1 = controlling anchor
465    #   $2 = name relative to controlling anchor
466    #   $3 = dir (relative to ${SRCDIR}) corresponding to $1
467    #
468    # This works by adding ML code to file $LIBLIST.  The code in this file
469    # will be executed near the end of this script.  If $MOVE_LIBRARIES is
470    # set to true, then reglib will also register a "movelib" to be executed at
471    # the end by putting a "movelib" line into $LIBMOVESCRIPT.
472    reglib() {
473        ANCHOR=$1
474        RELNAME=$2
475        LIBNAME='$'${ANCHOR}/${RELNAME}
476        ADIR=${SRCDIR}/$3
477        RELDIR=`dirname $RELNAME`
478        RELBASE=`basename $RELNAME`
479        if [ x$RELDIR = x. ] ; then
480            RELDIR=
481        else
482            RELDIR=/$RELDIR
483        fi
484        RELLOC=${RELDIR}/CM/${ARCH}-unix/${RELBASE}
485        SRCFINALLOC=${ADIR}${RELLOC}
486        if [ x$MOVE_LIBRARIES = xtrue ] ; then
487            FINALLOC=${LIBDIR}/${ANCHOR}${RELLOC}
488            FINALCONFIGPATH=${ANCHOR}
489        else
490            FINALLOC=${SRCFINALLOC}
491            FINALCONFIGPATH=${ADIR}
492        fi
493    
494        if [ -f ${FINALLOC} ] ; then
495            vsay "$this: Library ${LIBNAME} already exists in ${FINALLOC}"
496        else
497            vsay "$this: Scheduling library ${LIBNAME} to be built as ${FINALLOC}."
498            echo "  andalso CM.stabilize false \"${LIBNAME}\"" >>${LIBLIST}
499            echo ${ANCHOR} ${ADIR} >>${LOCALPATHCONFIG}
500            if [ x$MOVE_LIBRARIES = xtrue ] ; then
501                echo movelib ${SRCFINALLOC} ${FINALLOC} >>${LIBMOVESCRIPT}
502            fi
503        fi
504        echo ${ANCHOR} ${FINALCONFIGPATH} >>${CM_PATHCONFIG}
505    }
506    
507    #
508    # Function to build a standalone program such as ml-yacc.  The function takes
509    # 2 or 3 or 4 arguments.  First the name of the program which at the same time
510    # is the directory name under $SRCDIR/$4 where the sources reside.  The second
511    # argument is a descriptive name for the program (passed on to "unpack").
512    # The optional third argument specifies the path relative to $SRCDIR/$4/$1
513    # of the directory where the program's heap image is to be found.
514    # The fourth argument, if missing, defaults to "."
515    #
516    
517    standalone() {
518        TARGET=$1.$HEAP_SUFFIX
519        if [ $# = 3 ] ; then
520            TARGETLOC=$3/$TARGET
521        else
522            TARGETLOC=$TARGET
523        fi
524        if [ $# = 4 ] ; then
525             MYSRCDIR=$SRCDIR/$4
526        else
527             MYSRCDIR=$SRCDIR
528        fi
529        if [ -r $HEAPDIR/$TARGET ] ; then
530            vsay $this: Target $TARGET already exists.
531        else
532            echo $this: Building $TARGET.
533            unpack $2 $MYSRCDIR $1 $1
534            cd $MYSRCDIR/$1
535            # build it, but make sure we don't pick up some (unrelated)
536            # local path configuration...
537            CM_LOCAL_PATHCONFIG=/dev/null ./build
538            if [ -r $TARGETLOC ] ; then
539                mv $TARGETLOC $HEAPDIR/$TARGET
540                if [ ! -f $BINDIR/$1 ] ; then
541                    cd $BINDIR
542                    ln -s .run-sml $1
543                fi
544            else
545                echo "$this: !!! Build of $TARGET failed."
546            fi
547        fi
548    }
549    
550    ######################################################################
551    
552    #
553    # create the various sub directories
554    #
555    for dir in $BINDIR $HEAPDIR $RUNDIR $LIBDIR $SRCDIR ; do
556        makedir $dir
557    done
558    
559  #  #
560  # install the script that tests the architecture, and make sure that it works  # install the script that tests the architecture, and make sure that it works
561  #  #
562  if [ -x $BINDIR/.arch-n-opsys ]; then  if [ -x $BINDIR/.arch-n-opsys ]; then
563    echo "$BINDIR/.arch-n-opsys already exists"      vsay $this: Script $BINDIR/.arch-n-opsys already exists.
564  else  else
565    cat $CONFIGDIR/_arch-n-opsys | sed -e "s,@SHELL@,$SHELL,g" > $BINDIR/.arch-n-opsys      cat $CONFIGDIR/_arch-n-opsys \
566        | sed -e "s,@SHELL@,$SHELL,g" > $BINDIR/.arch-n-opsys
567    chmod 555 $BINDIR/.arch-n-opsys    chmod 555 $BINDIR/.arch-n-opsys
568    if [ ! -x $BINDIR/.arch-n-opsys ]; then    if [ ! -x $BINDIR/.arch-n-opsys ]; then
569      echo "!!! installation of $BINDIR/.arch-n-opsys failed for some reason"          complain "$this: !!! Installation of $BINDIR/.arch-n-opsys failed."
     exit 1  
570    fi    fi
571  fi  fi
572    
573  ARCH_N_OPSYS=`$BINDIR/.arch-n-opsys`  ARCH_N_OPSYS=`$BINDIR/.arch-n-opsys`
574  if [ "$?" != "0" ]; then  if [ "$?" != "0" ]; then
575    echo "!!! $BINDIR/.arch-n-opsys fails on this machine"      echo "$this: !!! Script $BINDIR/.arch-n-opsys fails on this machine."
576    echo "!!! you must patch this by hand and repeat the installation"      echo "$this: !!! You must patch this by hand and repeat the installation."
577    exit 2    exit 2
578  else  else
579    echo "$BINDIR/.arch-n-opsys reports $ARCH_N_OPSYS"      vsay $this: Script $BINDIR/.arch-n-opsys reports $ARCH_N_OPSYS.
580  fi  fi
581  eval $ARCH_N_OPSYS  eval $ARCH_N_OPSYS
582    
583  if [ -x $BINDIR/.run-sml ]; then  #
584    echo "$BINDIR/.run-sml already exists"  # Function to install a "driver" script...
585  else  #   This takes care of patching the source of the script with the SHELL,
586    cat $CONFIGDIR/_run-sml | \  #   BINDIR, and VERSION variables to use.
587      sed -e "s,@SHELL@,$SHELL,g" -e "s,@BINDIR@,$BINDIR," -e "s,@VERSION@,$VERSION," \  #
588      > $BINDIR/.run-sml  installdriver() {
589    chmod 555 $BINDIR/.run-sml      dsrc=$1
590    if [ ! -x $BINDIR/.run-sml ]; then      ddst=$2
591      echo "!!! installation of $BINDIR/.run-sml failed for some reason"  # We install the driver unconditionally. (It would be better to test
592      exit 1  # for an outdated driver script, but not all "test" commands understand
593    fi  # the -nt comparison operator....)
594    #   if [ -x $BINDIR/$ddst ]; then
595    #       echo $this: Script $BINDIR/$ddst already exists.
596    #   else
597            rm -f $BINDIR/$ddst
598            cat $CONFIGDIR/$dsrc | \
599            sed -e "s,@SHELL@,$SHELL,g" \
600                -e "s,@BINDIR@,$BINDIR," \
601                -e "s,@VERSION@,$VERSION," \
602                > $BINDIR/$ddst
603            chmod 555 $BINDIR/$ddst
604            if [ ! -x $BINDIR/$ddst ]; then
605                complain "$this: !!! Installation of $BINDIR/${ddst} failed."
606  fi  fi
607    #   fi
608    }
609    
610    installdriver _run-sml .run-sml
611    installdriver _link-sml .link-sml
612    installdriver _ml-build ml-build
613    installdriver _ml-makedepend ml-makedepend
614    
615  #  #
616  # set some architecture dependent run-time system flags  # set some architecture dependent run-time system flags
617  #  #
618  case $ARCH in  case $ARCH in
619    mips*) ALLOC=1M ;;      mips*)
620            ALLOC=1M
621            ;;
622    x86)    x86)
623            # The following is the _wrong_ value for many popular x86 chips
624            # (i.e., Celerons).  However, the optimal value for those is 32k,
625            # and such a small value is not enough for the runtime system's boot
626            # code.  Therefore, we use 256k here and re-set it to the proper
627            # value in .run-sml.
628      ALLOC=256k      ALLOC=256k
629    ;;    ;;
630    alpha32)    alpha32)
# Line 155  Line 634 
634      ALLOC=512k      ALLOC=512k
635    ;;    ;;
636  esac  esac
637    
638  case $OPSYS in  case $OPSYS in
639    solaris)    solaris)
640      MAKE=/usr/ccs/bin/make      MAKE=/usr/ccs/bin/make
# Line 162  Line 642 
642    linux)    linux)
643      EXTRA_DEFS=`$CONFIGDIR/chk-global-names.sh`      EXTRA_DEFS=`$CONFIGDIR/chk-global-names.sh`
644      if [ "$?" != "0" ]; then      if [ "$?" != "0" ]; then
645        echo "problems checking for underscores in global names"              complain "$this: !!! Problems checking for underscores in asm names."
       exit 1  
646      fi      fi
647      EXTRA_DEFS="XDEFS=$EXTRA_DEFS"      EXTRA_DEFS="XDEFS=$EXTRA_DEFS"
648    ;;    ;;
# Line 172  Line 651 
651  #  #
652  # the name of the bin files directory  # the name of the bin files directory
653  #  #
654  BIN_FILES=bin.$ARCH-unix  BOOT_ARCHIVE=boot.$ARCH-unix
655    BOOT_FILES=sml.$BOOT_ARCHIVE
656    
657  #  #
658  # build the run-time system  # build the run-time system
659  #  #
660  $CONFIGDIR/unpack.sh "run-time" $SRCDIR runtime $ROOT/$VERSION-runtime.tar  unpack "run-time" $SRCDIR runtime runtime
661  if [ "$?" != "0" ]; then  if [ -x $RUNDIR/run.$ARCH-$OPSYS ]; then
662    exit $?      vsay $this: Run-time system already exists.
663  fi  else
 if [ ! -x $RUNDIR/run.$ARCH-$OPSYS ]; then  
664    cd $SRCDIR/runtime/objs    cd $SRCDIR/runtime/objs
665    echo "compiling the run-time system"      echo $this: Compiling the run-time system.
666    $MAKE -f mk.$ARCH-$OPSYS $EXTRA_DEFS    $MAKE -f mk.$ARCH-$OPSYS $EXTRA_DEFS
667    if [ -x run.$ARCH-$OPSYS ]; then    if [ -x run.$ARCH-$OPSYS ]; then
668      mv run.$ARCH-$OPSYS $RUNDIR      mv run.$ARCH-$OPSYS $RUNDIR
669      $MAKE MAKE=$MAKE clean      $MAKE MAKE=$MAKE clean
670    else    else
671      echo "!!! run-time system build failed for some reason"          complain "$this: !!! Run-time system build failed for some reason."
     exit 1  
672    fi    fi
673  fi  fi
674  cd $SRCDIR  cd $SRCDIR
# Line 199  Line 677 
677  # boot the base SML system  # boot the base SML system
678  #  #
679  if [ -r $HEAPDIR/sml.$HEAP_SUFFIX ]; then  if [ -r $HEAPDIR/sml.$HEAP_SUFFIX ]; then
680    echo "$HEAPDIR/sml.$HEAP_SUFFIX already exists"      vsay $this: Heap image $HEAPDIR/sml.$HEAP_SUFFIX already exists.
681  else  else
682    $CONFIGDIR/unpack.sh bin $ROOT $BIN_FILES $ROOT/$VERSION-$BIN_FILES.tar      unpack bin $ROOT $BOOT_FILES $BOOT_ARCHIVE
683        cd $ROOT/$BOOT_FILES
684        if $BINDIR/.link-sml @SMLheap=$ROOT/sml @SMLboot=BOOTLIST @SMLalloc=$ALLOC
685        then
686    cd $ROOT    cd $ROOT
   $RUNDIR/run.$ARCH-$OPSYS @SMLboot=$ROOT/$BIN_FILES @SMLalloc=$ALLOC <<XXXX  
     $SET_FLAGS  
     val use = Compiler.Interact.useFile  
     val _ = (SMLofNJ.exportML "sml";  
              print Compiler.banner;  
              print "\n");  
 XXXX  
687    if [ -r sml.$HEAP_SUFFIX ]; then    if [ -r sml.$HEAP_SUFFIX ]; then
688      mv sml.$HEAP_SUFFIX $HEAPDIR      mv sml.$HEAP_SUFFIX $HEAPDIR
689      cd $BINDIR      cd $BINDIR
690      ln -s .run-sml sml      ln -s .run-sml sml
691                #
692                # Now move all stable libraries to #LIBDIR and generate
693                # the pathconfig file.
694                #
695                cd $ROOT/$BOOT_FILES
696                for anchor in * ; do
697                    if [ -d $anchor ] ; then
698                        echo $anchor $anchor >>$CM_PATHCONFIG
699                        move $anchor $LIBDIR/$anchor
700                    fi
701                done
702                cd $ROOT
703                # $BOOT_FILES is now only an empty skeleton, let's get rid of it.
704                rm -rf $BOOT_FILES
705    
706    else    else
707      echo "!!! unable to build SML heap image (sml.$HEAP_SUFFIX)"              complain "$this !!! No heap image generated (sml.$HEAP_SUFFIX)."
708      exit 1          fi
709        else
710            complain "$this !!! Boot code failed, no heap image (sml.$HEAP_SUFFIX)."
711    fi    fi
712  fi  fi
713    
714    #
715    # Initialize $LIBLIST
716    #
717    cd $ROOT
718    rm -f $LOCALPATHCONFIG $LIBLIST
719    echo 'ignore (OS.Process.exit (if true' >$LIBLIST
720    
721  #  #
722  # now build the individual targets  # now build (or prepare to build) the individual targets
723  #  #
724  cd $SRCDIR  cd $SRCDIR
725  echo "install targets"  vsay $this: Installing other targets.
726  for i in $TARGETS  for i in $TARGETS ; do
 do  
   if [ $i = "doc" ]; then  
     TARGET=$i  
   else  
     TARGET=$i.$HEAP_SUFFIX  
   fi  
   if [ -r $HEAPDIR/$TARGET ]; then  
     echo "$TARGET already exists"  
   else  
     echo "  building $TARGET"  
727      case $i in      case $i in
728        src-smlnj)        src-smlnj)
729          for src in compiler comp-lib cm MLRISC; do          for src in compiler cm MLRISC smlnj-lib ml-yacc system
730            $CONFIGDIR/unpack.sh $src $ROOT/src $src $ROOT/$VERSION-$src.tar          do
731                unpack $src $ROOT/src $src $src
732          done          done
733        ;;        ;;
       sml-full)  
         if [ ! -d $ROOT/$BIN_FILES ]; then  
           echo "!!! bin files are missing; build of $TARGET failed"  
           exit 1  
         else  
           cd $ROOT  
           $RUNDIR/run.$ARCH-$OPSYS @SMLfull @SMLboot=$ROOT/$BIN_FILES @SMLalloc=$ALLOC <<XXXX  
             $SET_FLAGS  
             val use = Compiler.Interact.useFile  
             val _ = (SMLofNJ.exportML "sml-full";  
                      print Compiler.banner;  
                      print " [full]\n");  
 XXXX  
           if [ -r sml-full.$HEAP_SUFFIX ]; then  
             mv sml-full.$HEAP_SUFFIX $HEAPDIR  
             cd $BINDIR  
             ln -s .run-sml sml-full  
           else  
             echo "!!! unable to build SML-FULL heap image"  
             exit 1  
           fi  
         fi  
       ;;  
734        ml-yacc)        ml-yacc)
735          $CONFIGDIR/unpack.sh ML-Yacc $SRCDIR ml-yacc $ROOT/$VERSION-ml-yacc.tar          standalone ml-yacc ML-Yacc src
736          if [ "$?" != "0" ]; then          echo ml-yacc $TOOLDIR >>$CM_PATHCONFIG
           exit $?  
         fi  
         cd $SRCDIR/ml-yacc  
         ./build  
         if [ -r src/$TARGET ]; then  
           mv src/$TARGET $HEAPDIR  
           if [ ! -f $BINDIR/$i ]; then  
             cd $BINDIR  
             ln -s .run-sml $i  
           fi  
         else  
           echo "!!! build of $TARGET failed"  
           exit 1  
         fi  
737        ;;        ;;
738        ml-lex)        ml-lex)
739          $CONFIGDIR/unpack.sh ML-Lex $SRCDIR ml-lex $ROOT/$VERSION-ml-lex.tar          standalone ml-lex ML-Lex
740          if [ "$?" != "0" ]; then          echo ml-lex $TOOLDIR >>$CM_PATHCONFIG
           exit $?  
         fi  
         cd $SRCDIR/ml-lex  
         ./build  
         if [ -r $TARGET ]; then  
           mv $TARGET $HEAPDIR  
           if [ ! -f $BINDIR/$i ]; then  
             cd $BINDIR  
             ln -s .run-sml $i  
           fi  
         else  
           echo "!!! build of $TARGET failed"  
           exit 1  
         fi  
741        ;;        ;;
742        ml-burg)        ml-burg)
743          $CONFIGDIR/unpack.sh ML-Burg $SRCDIR ml-burg $ROOT/$VERSION-ml-burg.tar          standalone ml-burg ML-Burg
744          if [ "$?" != "0" ]; then          echo ml-burg $TOOLDIR >>$CM_PATHCONFIG
745            exit $?          ;;
746          fi        ml-nlffigen)
747          cd $SRCDIR/ml-burg          echo standalone ml-nlffigen ML-NLFFI-Gen >>$LATESTANDALONES
748          ./build          echo ml-nlffigen $TOOLDIR >>$CM_PATHCONFIG
         if [ -r $TARGET ]; then  
           mv $TARGET $HEAPDIR  
           if [ ! -f $BINDIR/$i ]; then  
             cd $BINDIR  
             ln -s .run-sml $i  
           fi  
         else  
           echo "!!! build of $TARGET failed"  
           exit 1  
         fi  
749        ;;        ;;
750        smlnj-lib)        smlnj-lib)
751          $CONFIGDIR/unpack.sh "SML/NJ Library" $SRCDIR smlnj-lib $ROOT/$VERSION-smlnj-lib.tar          unpack "SML/NJ Library" $SRCDIR smlnj-lib smlnj-lib
752          if [ "$?" != "0" ]; then  
753            exit $?          # Don't make the Util library -- it came pre-made and has been
754          fi          # installed when making the base system.  In other words, don't do...
755        # make the Util library              #reglib smlnj-lib.cm smlnj-lib.cm smlnj-lib/Util
756          cd $SRCDIR/smlnj-lib/Util          # ... and don't make the HTML library ...
757          echo "$CM_MAKE_LIB" | $BINDIR/sml              #reglib html-lib.cm html-lib.cm smlnj-lib/HTML
758          if [ ! -f $LIBDIR/smlnj-lib.cm ]; then          # ... and don't make the PP library ...
759            cd $LIBDIR              #reglib pp-lib.cm pp-lib.cm smlnj-lib/PP
760            echo "Alias $SRCDIR/smlnj-lib/Util/sources.cm" > smlnj-lib.cm          # ... and don't make the controls library ...
761          fi              #reglib controls-lib.cm controls-lib.cm smlnj-lib/Controls
762        # make the Unix library        # make the Unix library
763          cd $SRCDIR/smlnj-lib/Unix              reglib unix-lib.cm unix-lib.cm smlnj-lib/Unix
764          echo "$CM_MAKE_LIB" | $BINDIR/sml          # make the INet library
765          if [ ! -f $LIBDIR/unix-lib.cm ]; then              reglib inet-lib.cm inet-lib.cm smlnj-lib/INet
           cd $LIBDIR  
           echo "Alias $SRCDIR/smlnj-lib/Unix/sources.cm" > unix-lib.cm  
         fi  
       # make the HTML library  
         cd $SRCDIR/smlnj-lib/HTML  
         echo "$CM_MAKE_LIB" | $BINDIR/sml  
         if [ ! -f $LIBDIR/html-lib.cm ]; then  
           cd $LIBDIR  
           echo "Alias $SRCDIR/smlnj-lib/HTML/sources.cm" > html-lib.cm  
         fi  
       # make the Reactive library  
         cd $SRCDIR/smlnj-lib/Reactive  
         echo "$CM_MAKE_LIB" | $BINDIR/sml  
         if [ ! -f $LIBDIR/reactive-lib.cm ]; then  
           cd $LIBDIR  
           echo "Alias $SRCDIR/smlnj-lib/Reactive/sources.cm" > reactive-lib.cm  
         fi  
       # make the PP library  
         cd $SRCDIR/smlnj-lib/PP  
         echo "$CM_MAKE_LIB" | $BINDIR/sml  
         if [ ! -f $LIBDIR/pp-lib.cm ]; then  
           cd $LIBDIR  
           echo "Alias $SRCDIR/smlnj-lib/PP/sources.cm" > pp-lib.cm  
         fi  
766        # make the RegExp library        # make the RegExp library
767          cd $SRCDIR/smlnj-lib/RegExp              reglib regexp-lib.cm regexp-lib.cm smlnj-lib/RegExp
768          echo "$CM_MAKE_LIB" | $BINDIR/sml          # make the Reactive library
769          if [ ! -f $LIBDIR/regexp-lib.cm ]; then              reglib reactive-lib.cm reactive-lib.cm smlnj-lib/Reactive
770            cd $LIBDIR          # make the HashCons library
771            echo "Alias $SRCDIR/smlnj-lib/RegExp/sources.cm" > regexp-lib.cm              reglib hash-cons-lib.cm hash-cons-lib.cm smlnj-lib/HashCons
         fi  
       ;;  
       ml-yacc-lib)  
         $CONFIGDIR/unpack.sh ML-Yacc $SRCDIR ml-yacc $ROOT/$VERSION-ml-yacc.tar  
         if [ "$?" != "0" ]; then  
           exit $?  
         fi  
         cd $SRCDIR/ml-yacc/lib  
         echo "$CM_MAKE_LIB" | $BINDIR/sml  
         if [ ! -f $LIBDIR/ml-yacc-lib.cm ]; then  
           cd $LIBDIR  
           echo "Alias $SRCDIR/ml-yacc/lib/sources.cm" > ml-yacc-lib.cm  
         fi  
772        ;;        ;;
773        cml)        cml)
774          $CONFIGDIR/unpack.sh CML $SRCDIR cml $ROOT/$VERSION-cml.tar          unpack CML $SRCDIR cml cml
775          if [ "$?" != "0" ]; then          reglib cml core-cml.cm cml/src
776            exit $?          reglib cml cml-internal.cm cml/src
777          fi          reglib cml cml.cm cml/src
778          cd $SRCDIR/cml/src          reglib cml basis.cm cml/src
         echo "$CM_MAKE_LIB" | $BINDIR/sml  
         if [ ! -f $LIBDIR/cml.cm ]; then  
           cd $LIBDIR  
           echo "Alias $SRCDIR/cml/src/sources.cm" > cml.cm  
         fi  
779        ;;        ;;
780        cml-lib)        cml-lib)
781          $CONFIGDIR/unpack.sh CML $SRCDIR cml $ROOT/$VERSION-cml.tar          unpack CML $SRCDIR cml cml
782          if [ "$?" != "0" ]; then          reglib cml-lib trace-cml.cm cml/cml-lib/cm
783            exit $?          reglib cml-lib smlnj-lib.cm cml/cml-lib/cm
         fi  
         cd $SRCDIR/cml/cml-lib  
         echo "$CM_MAKE_LIB" | $BINDIR/sml  
         if [ ! -f $LIBDIR/cml-lib.cm ]; then  
           cd $LIBDIR  
           echo "Alias $SRCDIR/cml/cml-lib/sources.cm" > cml-lib.cm  
         fi  
       ;;  
       cml-cm)  
         CMD="CM.autoloading(SOME true); CM.clearAutoList();"  
         CMD="$CMD CM.autoload'(\"$LIBDIR/cml.cm\");"  
         if [ "$AUTOLOAD_CML_LIB" = "TRUE" ]; then  
           CMD="$CMD CM.autoload'(\"$LIBDIR/cml-lib.cm\");"  
         fi  
         if [ "$AUTOLOAD_EXENE" = "TRUE" ]; then  
           CMD="$CMD CM.autoload'(\"$LIBDIR/eXene.cm\");"  
         fi  
         cd $ROOT  
         $BINDIR/sml <<XXXX  
           $CMD  
           val _ = (SMLofNJ.exportML "$i";  
                 print CML.banner;  
                 print "[CML autoload]\n");  
 XXXX  
         if [ -r $TARGET ]; then  
           mv $TARGET $HEAPDIR  
           if [ ! -f $BINDIR/$i ]; then  
             cd $BINDIR  
             ln -s .run-sml $i  
           fi  
         else  
           echo "!!! unable to build autoloading CML"  
           exit 1  
         fi  
784        ;;        ;;
785        eXene)        eXene)
786          $CONFIGDIR/unpack.sh EXene $SRCDIR eXene $ROOT/$VERSION-eXene.tar          unpack EXene $SRCDIR eXene eXene
787          if [ "$?" != "0" ]; then          reglib eXene.cm eXene.cm eXene
788            exit $?          ;;
789          fi        ckit)
790          cd $SRCDIR/eXene          unpack "C-Kit" $ROOT ckit ckit
791          echo "$CM_MAKE_LIB" | $BINDIR/sml          reglib ckit-lib.cm ckit-lib.cm ../ckit/src
792          if [ ! -f $LIBDIR/eXene.cm ]; then          ;;
793            cd $LIBDIR        ml-nlffi-lib)
794            echo "Alias $SRCDIR/eXene/sources.cm" > eXene.cm          unpack "NLFFI Library" $SRCDIR ml-nlffi-lib ml-nlffi-lib
795          fi          reglib c memory/memory.cm ml-nlffi-lib
796            reglib c internals/c-int.cm ml-nlffi-lib
797            reglib c c.cm ml-nlffi-lib
798            ;;
799          pgraph-util)
800            unpack "CM source code" $SRCDIR cm cm
801            reglib pgraph-util.cm pgraph-util.cm cm/pgraph
802            ;;
803          mlrisc-tools)
804            unpack "MLRISC Tools Library" $SRCDIR MLRISC MLRISC
805            reglib mlrisc-tools pp.cm MLRISC/Tools
806            reglib mlrisc-tools source-map.cm MLRISC/Tools
807            reglib mlrisc-tools sml-ast.cm MLRISC/Tools
808            reglib mlrisc-tools prec-parser.cm MLRISC/Tools
809            reglib mlrisc-tools parser.cm MLRISC/Tools
810            reglib mlrisc-tools match-compiler.cm MLRISC/Tools
811            ;;
812          nowhere)
813            unpack "MLRISC Tools Library" $SRCDIR MLRISC MLRISC
814            echo standalone nowhere NoWhere . MLRISC/Tools >>$LATESTANDALONES
815            echo nowhere $TOOLDIR >>$CM_PATHCONFIG
816        ;;        ;;
817        doc)        doc)
818          $CONFIGDIR/unpack.sh Doc $ROOT doc $ROOT/$VERSION-doc.tar          echo Package doc is currently unavailable.
819          if [ "$?" != "0" ]; then          # unpack Doc $ROOT doc doc
820            exit $?          # cd $ROOT/doc
821          fi          # build $ROOT
         cd $ROOT/doc  
         build $ROOT  
822        ;;        ;;
823        *)        *)
824          echo "!!! unknown target $i"          echo "$this: !!! Unknown target $i."
825        ;;        ;;
826      esac      esac
   fi  
827  done  done
828    
829  if [ "$ENABLE_AUTOLOADING" = "TRUE" ]; then  #
830    CMD="CM.autoloading(SOME true); CM.clearAutoList();"  # Now go and stabilize all registered libraries...
831    if [ "$AUTOLOAD_SMLNJ_LIB" = "TRUE" ]; then  # This is done with library sources in their original locations inside
832      CMD="$CMD CM.autoload'(\"$LIBDIR/smlnj-lib.cm\");"  # $SRCDIR, so we must consult $LOCALPATHCONFIG.
833    fi  #
834    if [ "$AUTOLOAD_SMLNJ_UNIX" = "TRUE" ]; then  
835      CMD="$CMD CM.autoload'(\"$LIBDIR/unix-lib.cm\");"  echo $this: Compiling library code.
836    fi  echo 'then OS.Process.success else OS.Process.failure));' >>$LIBLIST
837    if [ "$AUTOLOAD_SMLNJ_HTML" = "TRUE" ]; then  if CM_LOCAL_PATHCONFIG=$LOCALPATHCONFIG $BINDIR/sml <$LIBLIST ; then
838      CMD="$CMD CM.autoload'(\"$LIBDIR/html-lib.cm\");"      vsay $this: Libraries compiled successfully.
839    fi  else
840    if [ "$AUTOLOAD_SMLNJ_REACTIVE" = "TRUE" ]; then      complain "$this: !!! Something went wrong when compiling the libraries."
     CMD="$CMD CM.autoload'(\"$LIBDIR/reactive-lib.cm\");"  
   fi  
   if [ "AUTOLOAD_SMLNJ_PP" = "TRUE" ]; then  
     CMD="$CMD CM.autoload'(\"$LIBDIR/pp-lib.cm\");"  
841    fi    fi
842    if [ "AUTOLOAD_SMLNJ_REGEXP" = "TRUE" ]; then  
843      CMD="$CMD CM.autoload'(\"$LIBDIR/regexp-lib.cm\");"  #
844    # Move the libraries to their final locations...
845    #
846    
847    if [ -r $LIBMOVESCRIPT ] ; then
848        vsay $this: Moving libraries to $LIBDIR.
849        . $LIBMOVESCRIPT
850    fi    fi
851    cd $ROOT  
852    $BINDIR/sml <<XXXX  #
853      $CMD  # Build "late" standalone programs (i.e., those that must be built
854      val _ = (SMLofNJ.exportML "sml";  # after libraries are already in place):
855               print Compiler.banner;  #
856               print " [CM; autoload enabled]\n");  
857  XXXX  if [ -r $LATESTANDALONES ] ; then
858    if [ -r sml.$HEAP_SUFFIX ]; then      vsay $this: Building late standalone programs.
859      mv sml.$HEAP_SUFFIX $HEAPDIR      . $LATESTANDALONES
   else  
     echo "!!! unable to build SML with autoloading"  
     exit 1  
860    fi    fi
861    
862    #
863    # Finally, remove duplicate entries from pathconfig file...
864    #
865    if [ -f $CM_PATHCONFIG ] ; then
866        cp $CM_PATHCONFIG $PCEDITTMP
867        rm -f $CM_PATHCONFIG
868        awk <$PCEDITTMP 'NF == 2 { mapping[$1] = $2 }
869    NF != 2 { print $0 }
870    END { for (i in mapping) print i, mapping[i] }' \
871          | sort >$CM_PATHCONFIG
872  fi  fi
873    
874    exit 0

Legend:
Removed from v.249  
changed lines
  Added in v.1251

root@smlnj-gforge.cs.uchicago.edu
ViewVC Help
Powered by ViewVC 1.0.0